=== tests/configandwatch_test/CMakeLists.txt ===
log4cplus_add_test(configandwatch_test main.cxx)
