=== tests/customloglevel_test/CMakeLists.txt ===
log4cplus_add_test(customloglevel_test main.cxx func.cxx customloglevel.cxx)
