=== tests/filter_test/CMakeLists.txt ===
log4cplus_add_test(filter_test main.cxx)
