=== tests/priority_test/CMakeLists.txt ===
log4cplus_add_test(priority_test  main.cxx func.cxx)
