=== debian/changelog ===
log4cplus (2.0.5-3) unstable; urgency=medium

  * Dont leak Catch symbols in shared library by building without unit-tests
    for the package. To ensure that unit tests are still run, build the library
    with unit-tests separately. Closes: #978617.

 -- Tobias Frost <tobi@debian.org>  Tue, 12 Jan 2021 16:48:11 +0100

log4cplus (2.0.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Tue, 03 Nov 2020 18:38:12 +0100

log4cplus (2.0.5-1) experimental; urgency=medium

  * New upstream release. (Closes: #929062)
    - Uploading to experimental to prepare for library transition.
    - Rename library package for new library name.
    - Update d/*.install for new version.
  * Switch to cmake builds to generate the cmake module.
    - new B-D on cmake
    - drop B-Ds on automake and libtool.
  * New liblog4cplus-doc arch:all package with the library documentation:
    - move doxygen B-D to B-D-Indep, add graphviz to B-D-Indep.
    - Add -indep rules to d/rules to generate the doxygen docs.
    - Override build and test targets for indep to be no-ops to avoid build
      failures when building arch:all only.
  * New patches:
    - generate pkgconfig file with CMake.
    - make sure SO-NAME between CMake and autotools builds are same.
      This patch also makes the dh_links override obsolete.
    - patch for to ease docs generation.
    - spelling fixes patch.
  * d/clean: Remove embedded code copy of catch and some autogenerated files
    using d/clean.
  * Salsa-CI: Temporarily disabling repotest, until there is time to find out
    why this package stopped being reproducible.
  * Add d/.gitignore to overrides upstreams' and unhide d/patches.

 -- Tobias Frost <tobi@debian.org>  Thu, 29 Oct 2020 20:33:11 +0100
