=== debian/control ===
Source: log4cplus
Section: libs
Priority: optional
Maintainer: Andrew Pollock <apollock@debian.org>
Uploaders:
 Tobias Frost <tobi@debian.org>
Build-Depends:
 cmake,
 catch,
 debhelper-compat (= 13),
# libtool
Build-Depends-Indep:
 doxygen,
 graphviz,
 jdupes
Standards-Version: 4.5.0
Homepage: https://sourceforge.net/p/log4cplus/wiki/Home
Vcs-Browser: https://salsa.debian.org/debian/log4cplus
Vcs-Git: https://salsa.debian.org/debian/log4cplus.git
Rules-Requires-Root: no

Package: liblog4cplus-2.0.5
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: C++ logging API modeled after the Java log4j API - shared library
 log4cplus is a simple to use C++ logging API providing thread-safe,
 flexible, and arbitrarily granular control over log management and
 configuration.  It is modeled after the Java log4j API.

Package: liblog4cplus-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 liblog4cplus-2.0.5 (= ${binary:Version}),
 ${misc:Depends}
Description: C++ logging API modeled after the Java log4j API - development library
 log4cplus is a simple to use C++ logging API providing thread-safe,
 flexible, and arbitrarily granular control over log management and
 configuration.  It is modeled after the Java log4j API.
 .
 This package contains the header files and static library for
 developers.

Package: liblog4cplus-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends}
Suggests: liblog4cplus-dev
Description: C++ logging API modeled after the Java log4j API - doxygen documentation
 log4cplus is a simple to use C++ logging API providing thread-safe,
 flexible, and arbitrarily granular control over log management and
 configuration.  It is modeled after the Java log4j API.
 .
 This package contains the html doxygen documentation.
