=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND := --std=c++11
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	# building tests separately, see #978617
	dh_auto_clean --builddirectory build-with-tests

override_dh_auto_configure-arch:
	dh_auto_configure -- -DWITH_UNIT_TESTS=OFF
	dh_auto_configure --builddirectory build-with-tests

override_dh_auto_build-arch:
	dh_auto_build
	dh_auto_build --builddirectory build-with-tests

override_dh_strip:
	dh_strip --dbgsym-migration='liblog4cplus-dbg (<< 1.1.2-4~)'

override_dh_auto_build-indep:
	cd docs && mkdir -p log4cplus-2.0.5/docs && doxygen doxygen.config

override_dh_installdocs-indep:
	dh_installdocs -i
	dh_doxygen

override_dh_link-indep:
	dh_link
	jdupes -rl debian/liblog4cplus-doc/usr/share/doc/liblog4cplus-dev/html/

override_dh_auto_test-arch:
	dh_auto_test --builddirectory build-with-tests

# nothing todo for indep:
override_dh_auto_install-indep:
override_dh_auto_test-indep:
