=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://sf.net/log4cplus/log4cplus-([0-9]+\..+)\.tar\.(?:gz|xz|bz2) debian uupdate
